#pragma once

#include "types.h"

#include <essentials/types.h>

#include <string>
#include <vector>

using namespace Essentials;

namespace Image
{
	bool Load(const std::string& fileName, byte*& data, uint16& width, uint16& height, Format::TYPE& format);
	bool Save(const std::string& fileName, byte* data, uint16 width, uint16 height, Format::TYPE format);
	bool IsCompressed(Format::TYPE format);
	bool Is32(Format::TYPE format);
	byte BPP(Format::TYPE format);
	byte PixelSize(Format::TYPE format);
	uint32 Size(uint16 width, uint16 height, Format::TYPE format);
	byte MipmapsCount(uint16 width, uint16 height);
	byte* Scale(byte* data, uint16 width, uint16 height, Format::TYPE& format, uint16 scaledWidth, uint16 scaledHeight, Filter::TYPE filter);
	std::vector<Mipmap> GenerateMipmaps(byte* data, uint16 width, uint16 height, Format::TYPE format, Filter::TYPE filter);
	void SwapChannels(byte* data, uint16 width, uint16 height, Format::TYPE format, byte firstChannelIndex, byte secondChannelIndex);
	byte* Shift(byte* data, uint16 width, uint16 height, Format::TYPE format, uint16 xOffset, uint16 yOffset);
	byte* Compress(byte* data, uint16 width, uint16 height, Format::TYPE desiredFormat); // data must be RGBA8
	byte* Decompress(byte* data, uint16 width, uint16 height, Format::TYPE format);
}
