#pragma once

#include "types.h"

namespace Math
{
	void Intersection(
		const Vector3& startPoint,
		const Vector3& direction,
		const Plane& plane,
		Vector3& intersectionPoint,
		float& t);

	//

	inline void Intersection(
		const Vector3& startPoint,
		const Vector3& direction,
		const Plane& plane,
		Vector3& intersectionPoint,
		float& t)
	{
		t = -(plane.a*startPoint.x + plane.b*startPoint.y + plane.c*startPoint.z + plane.d) / (plane.a*direction.x + plane.b*direction.y + plane.c*direction.z);
		intersectionPoint = startPoint + t*direction;
	}
}
