#pragma once

#include <cstdlib>
#include <ctime>

#include <essentials/types.h>

using namespace Essentials;

namespace Math
{
	void Randomize();

	uint16 Random16();
	uint16 Random16(uint16 from, uint16 to);

	uint32 Random32();
	uint32 Random32(uint32 from, uint32 to);

	float RandomFloat(); // [0..1]
	float RandomFloat(float from, float to);

	//

	inline void Randomize()
	{
		srand((uint)time(NULL));
	}

	inline uint16 Random16()
	{
		uint16 r1 = rand() % 256; // 2^8
		uint16 r2 = rand() % 256; // 2^8

		return (r1) | (r2 << 8 );
	}

	inline uint16 Random16(uint16 from, uint16 to)
	{
		return from + (Random16() % (to - from + 1));
	}

	inline uint32 Random32()
	{
		uint32 r1 = rand() % 2048; // 2^11
		uint32 r2 = rand() % 2048; // 2^11
		uint32 r3 = rand() % 1024; // 2^10

		return (r1) | (r2 << 11) | (r3 << 22);
	}

	inline uint32 Random32(uint32 from, uint32 to)
	{
		return from + (Random32() % (to - from + 1));
	}

	inline float RandomFloat()
	{
		return (float)(rand() - 1) / (float)RAND_MAX;
	}

	inline float RandomFloat(float from, float to)
	{
		return from + (RandomFloat() * (to - from));
	}
}
