#include <image/main.h>
#include <essentials/macros.h>

#include <FreeImage.h>

#include <cstdio>

void FreeImageCustomOutputMessageFunction(FREE_IMAGE_FORMAT fif, const char* msg)
{
	SAFE_CALL(Image::outputMessageFunction)(std::string("ERROR (FreeImage): ") + std::string(msg));
}

void Image::Initialize()
{
	FreeImage_Initialise();
	FreeImage_SetOutputMessage(FreeImageCustomOutputMessageFunction);
}

void Image::Deinitialize()
{
	FreeImage_DeInitialise();
}

void Image::SetFreeImageCustomOutputMessageFunction(void (*_outputMessageFunction)(const std::string& msg))
{
	outputMessageFunction = _outputMessageFunction;
}

void (*Image::outputMessageFunction)(const std::string& msg);
